package ui;

import java.awt.BorderLayout;
import java.awt.Graphics;
import java.awt.Graphics2D;

import javax.swing.JFrame;
import javax.swing.JPanel;
import core.Mapper;

public class MapperUI extends JFrame{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private MapperPanel mapperPanel=null;
	private Mapper mapper=null;
	
	public MapperUI(Mapper mapper){
		this.mapper=mapper;
		setTitle("Mapper");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setLayout(new BorderLayout());
		setResizable(false);
		mapperPanel=new MapperPanel();
		add(mapperPanel,BorderLayout.CENTER);
		pack();
		setVisible(true);
	}
	
	
	class MapperPanel extends JPanel{
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		public MapperPanel(){
			setPreferredSize(mapper.getDimension());
		}
		protected void paintComponent(Graphics g){
			Graphics2D g2d=(Graphics2D)g;
			g2d.drawImage(mapper.getImage(),null,this);
		}
	}
}
