package ui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;

import core.Mapper;

public class MapperUIButton extends JFrame{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private MapperPanel mapperPanel=null;
	private ControlPanel controlPanel=null;
	private Mapper mapper=null;
	
	ZoomMoins zm;
	ZoomPlus zp;
	
	ButtonPanel z;
	
	public MapperUIButton(Mapper mapper){
		this.mapper=mapper;
		setTitle("Mapper");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setLayout(new BorderLayout());
		setResizable(false);
		mapperPanel=new MapperPanel();
		controlPanel=new ControlPanel();
		add(mapperPanel,BorderLayout.LINE_START);
		add(controlPanel,BorderLayout.CENTER);
		pack();
		setVisible(true);
	}
	
	class ControlPanel extends JPanel{
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;

		public ControlPanel(){
			setLayout(new BoxLayout(this,BoxLayout.PAGE_AXIS));
			setBorder(BorderFactory.createTitledBorder("Control"));
			
			zm=new ZoomMoins();
			zm.setText("-");
			zm.addActionListener(zm);
			
			zp=new ZoomPlus();
			zp.setText("+");
			zp.addActionListener(zp);
					
			z=new ButtonPanel("zoom");
			z.add(zp);
			z.add(zm);
			
			add(z);
		}
	}
	
	
	class ZoomPlus extends JButton implements ActionListener{
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;

		public void actionPerformed(ActionEvent e) {
			mapper.setZoom(mapper.getZoom()+0.01);
			mapperPanel.repaint();
		}
	}
	
	class ZoomMoins extends JButton implements ActionListener{
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;

		public void actionPerformed(ActionEvent e) {
			mapper.setZoom(mapper.getZoom()-0.01);
			mapperPanel.repaint();
		}
	}
	
	
	class MapperPanel extends JPanel{
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		public MapperPanel(){
			setPreferredSize(mapper.getDimension());
			setBackground(Color.blue);
		}
		protected void paintComponent(Graphics g){
			Graphics2D g2d=(Graphics2D)g;
			g2d.drawImage(mapper.getImage(),null,this);
		}
	}
	
	class ButtonPanel extends JPanel{
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;

		public ButtonPanel(String name){
			setBorder(BorderFactory.createTitledBorder(name));
		}
	}
}
